///home/berryj/link/bin/genMethods "-g" "-t" "Set<Edge*>" "-h" "Collection" "-c" "Edge*" "-I" "LINK/graph/Edge.h" "-I" "LINK/stkWrapper/SetFuncsWrapper.h" "-I" "LINK/basic/SetFuncs.h" "-I" "LINK/basic/Set.h" "-d" "graph" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/graph/Edge.h>

#include <LINK/stkWrapper/SetFuncsWrapper.h>

#include <LINK/basic/SetFuncs.h>

#include <LINK/basic/Set.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>
#include <LINK/stkWrapper/CollectionWrapper.h>


typedef Set<Edge*> _Set_Edge__;
typedef Collection<Set<Edge*> > _Collection_Set_Edge___;

#define _Collection_Set_Edge___DATA(x) ((Collection<Set<Edge*> >*) (EXTDATA(x)))
#define _Collection_Set_Edge___IS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<Collection<Set<Edge*> > >::type))
#define _Collection_Set_Edge___ISNT_DATA(x) (!_Collection_Set_Edge___IS_DATA(x))

#define _Collection_Set_Edge___CXX_DATA(x) (*(Collection<Set<Edge*> >*) (EXTDATA(VAL(x))))
#define _Collection_Set_Edge___CXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<Collection<Set<Edge*> > >::type))
#define _Collection_Set_Edge___CXX_ISNT_DATA(x) (!_Collection_Set_Edge___CXX_IS_DATA(x))


PRIMITIVE STk_init__Collection_Set_Edge___()
{
	Wrapper<_Collection_Set_Edge___>::type = STk_new_CXXwrapper_id(
			Wrapper<_Collection_Set_Edge___>::name, 
			"",
			(void (*)(SCM x, SCM port, int mode))
			CollectionWrapper<_Set_Edge__>::displayTypedCollection,
			(void (*)(SCM x))CollectionWrapper<_Set_Edge__>::markTypedCollection,
			(void (*)(SCM x))CollectionWrapper<_Set_Edge__>::freeTypedCollection);
	Tcl_InitHashTable(&Register<_Collection_Set_Edge___>::objTable, TCL_ONE_WORD_KEYS);
	return UNDEFINED;
}

void genExtra_Collection_Set_Edge___Methods(void);

PRIMITIVE STk_init_methods__Collection_Set_Edge___()
{
	STk_add_new_cpp_primitive("collection-Set-Edge?", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Edge__>::collectionP);
	STk_add_new_cpp_primitive("mset-Set-Edge1", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Edge__>::buildMSet);
	STk_add_new_cpp_primitive("set-Set-Edge1", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Edge__>::buildSet);
	STk_add_new_cpp_primitive("sequence-Set-Edge1", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Edge__>::buildSequence);
	STk_add_new_cpp_primitive("Collection-Set-Edge-sorted?", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Edge__>::sortedLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-Edge-size", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Edge__>::sizeLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-Edge-null?", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Edge__>::nullLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-Edge-eqv?", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Edge__>::eqvLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-Edge-<", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Edge__>::lthLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-Edge-<=", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Edge__>::leLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-Edge->", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Edge__>::grLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-Edge->=", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Edge__>::geLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-Edge-member", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Edge__>::memberLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-Edge-clear!", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Edge__>::clearLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-Edge-insert!", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Edge__>::insertLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-Edge-append!", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Edge__>::appendLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-Edge-remove!", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Edge__>::removeLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-Edge-occurrences", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Edge__>::occurrencesLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-Edge-ref", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Edge__>::refLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-Edge-rank", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Edge__>::rankLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-Edge-+", tc_subr_1_or_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Edge__>::unionLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-Edge-^", tc_subr_1_or_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Edge__>::intersectionLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-Edge--", tc_subr_1_or_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Edge__>::differenceLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-Edge-subset", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Edge__>::subsetLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-Edge-proper-subset", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Edge__>::properSubsetLinkCollection);
	STk_add_new_cpp_primitive("list->mset-Set-Edge", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Edge__>::stkList2LinkMSet);
	STk_add_new_cpp_primitive("list->set-Set-Edge", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Edge__>::stkList2LinkSet);
	STk_add_new_cpp_primitive("list->sequence-Set-Edge", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Edge__>::stkList2LinkSequence);
	STk_add_new_cpp_primitive("mset-Set-Edge->list", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Edge__>::collection2STkList);
	STk_add_new_cpp_primitive("set-Set-Edge->list", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Edge__>::collection2STkList);
	STk_add_new_cpp_primitive("sequence-Set-Edge->list", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Edge__>::collection2STkList);
	STk_add_new_cpp_primitive("mset-Set-Edge->string", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Edge__>::collection2STkString);
	STk_add_new_cpp_primitive("set-Set-Edge->string", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Edge__>::collection2STkString);
	STk_add_new_cpp_primitive("sequence-Set-Edge->string", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_Edge__>::collection2STkString);
	STk_add_new_cpp_primitive("Collection-Set-Edge-cartesian-product", tc_subr_2, 
	(PRIMITIVE (*)(...))  SetFuncsWrapper<Edge* >::cartesianProduct);
	STk_add_new_cpp_primitive("Collection-Set-Edge-choose", tc_subr_2, 
	(PRIMITIVE (*)(...))  SetFuncsWrapper<Edge* >::choose);
	STk_add_new_cpp_primitive("Collection-Set-Edge-power-set", tc_subr_1, 
	(PRIMITIVE (*)(...))  SetFuncsWrapper<Edge* >::powerSet);
	STk_add_new_cpp_primitive("Collection-Set-Edge-permutations", tc_subr_1, 
	(PRIMITIVE (*)(...))  SetFuncsWrapper<Edge* >::permutations);
	STk_add_new_cpp_primitive("Collection-Set-Edge-permutation", tc_subr_2, 
	(PRIMITIVE (*)(...))  SetFuncsWrapper<Edge* >::permutation);
	STk_add_new_cpp_primitive("Collection-Set-Edge-permutation-rank", tc_subr_1, 
	(PRIMITIVE (*)(...))  SetFuncsWrapper<Edge* >::rank);

	addListMethod("mset-Set-Edge",
		"mset-Set-Edge1", LINK_NEW);
	addListMethod("set-Set-Edge",
		"set-Set-Edge1", LINK_NEW);
	addListMethod("sequence-Set-Edge",
		"sequence-Set-Edge1", LINK_NEW);
	addOneArgMethod("null?",
		Wrapper<_Collection_Set_Edge___ >::name, 
		"Collection-Set-Edge-null?", LINK_OVL);
	addOneArgMethod("size",
		Wrapper<_Collection_Set_Edge___ >::name, 
		"Collection-Set-Edge-size", LINK_NEW);
	addTwoArgMethod("eqv?",
		Wrapper<_Collection_Set_Edge___ >::name, 
		Wrapper<_Collection_Set_Edge___ >::name, 
		"Collection-Set-Edge-eqv?", LINK_OVL);
	addBooleanMethod("<",
		Wrapper<_Collection_Set_Edge___ >::name, 
		"Collection-Set-Edge-<", LINK_OVL);
	addBooleanMethod("<=",
		Wrapper<_Collection_Set_Edge___ >::name, 
		"Collection-Set-Edge-<=", LINK_OVL);
	addBooleanMethod(">",
		Wrapper<_Collection_Set_Edge___ >::name, 
		"Collection-Set-Edge->", LINK_OVL);
	addBooleanMethod(">=",
		Wrapper<_Collection_Set_Edge___ >::name, 
		"Collection-Set-Edge->=", LINK_OVL);
	addTwoArgMethod("member",
		Wrapper<_Set_Edge__ >::name, 
		Wrapper<_Collection_Set_Edge___ >::name, 
		"Collection-Set-Edge-member", LINK_OVL);
	addTwoArgMethod("ref",
		Wrapper<_Collection_Set_Edge___ >::name, 
		"<integer>",
		"Collection-Set-Edge-ref", LINK_NEW);
	addOneArgMethod("clear!",
		Wrapper<_Collection_Set_Edge___ >::name, 
		"Collection-Set-Edge-clear!", LINK_NEW);
	addTwoArgMethod("insert!",
		Wrapper<_Set_Edge__ >::name, 
		Wrapper<_Collection_Set_Edge___ >::name, 
		"Collection-Set-Edge-insert!", LINK_NEW);
	addTwoArgMethod("append!",
		Wrapper<_Set_Edge__ >::name, 
		Wrapper<_Collection_Set_Edge___ >::name, 
		"Collection-Set-Edge-append!", LINK_NEW);
	addTwoArgMethod("remove!",
		Wrapper<_Set_Edge__ >::name, 
		Wrapper<_Collection_Set_Edge___ >::name, 
		"Collection-Set-Edge-remove!", LINK_NEW);
	addArbMethod("+",
		Wrapper<_Collection_Set_Edge___ >::name, 
		"Collection-Set-Edge-+", LINK_OVL);
	addArbMethod("^",
		Wrapper<_Collection_Set_Edge___ >::name, 
		"Collection-Set-Edge-^", LINK_NEW);
	addArbMethod("-",
		Wrapper<_Collection_Set_Edge___ >::name, 
		"Collection-Set-Edge--", LINK_OVL);
	addTwoArgMethod("cartesian-product",
		Wrapper<_Set_Edge__ >::name, 
		Wrapper<_Set_Edge__ >::name, 
		"Collection-Set-Edge-cartesian-product", LINK_NEW);
	addTwoArgMethod("choose",
		Wrapper<_Set_Edge__ >::name, 
		"<integer>",
		"Collection-Set-Edge-choose", LINK_NEW);
	addOneArgMethod("power-set",
		Wrapper<_Set_Edge__ >::name, 
		"Collection-Set-Edge-power-set", LINK_NEW);
	addOneArgMethod("permutations",
		Wrapper<_Set_Edge__ >::name, 
		"Collection-Set-Edge-permutations", LINK_NEW);
	addTwoArgMethod("permutation",
		Wrapper<_Set_Edge__ >::name, 
		"<integer>",
		"Collection-Set-Edge-permutation", LINK_NEW);
	addOneArgMethod("permutation-rank",
		Wrapper<_Set_Edge__ >::name, 
		"Collection-Set-Edge-permutation-rank", LINK_NEW);
	genExtra_Collection_Set_Edge___Methods();
	return UNDEFINED;
}
